#ifndef DATABASE_H
#define DATABASE_H 1

#include <sqlite3.h>

#include <string>
#include <vector>

#include "Task.h"

class Database {
    sqlite3 * ppDb;
    
    std::string path;
public:
    Database(const std::string & path);
    ~Database();
    
    bool open();
    bool exec(const std::string & str);
    bool exec(const std::string & str,
		const std::map<std::string,std::string> & bindings);
    bool exec(const std::string & str,
		const std::map<std::string,std::string> & bindings,
    		void (*data)(void *, std::vector<std::string*> &),void * callbackarg);
    bool exec(const std::string & str,
    		void (*data)(void *, std::vector<std::string*> &),void * callbackarg);
    void close();
    
    
    static TaskQueue * dbTaskQueue;
    static void initDatabase();
};

#endif

