#include <SDL.h>
#include <SDL_image.h>

#include "Graphs.h"
#include "Application.h"
#include "GridWidget.h"
#include <string>

GridWidget::GridWidget() : Widget()
{
    cellWidth = 16;
    cellHeight = 16;
    childCount = 0;
    focusedX = 0;
    focusedY = 0;
}

void GridWidget::removeChilds()
{
    Widget::removeChilds();
    childCount = 0;
    focusedX = 0;
    focusedY = 0;
}

void GridWidget::placeChild(Widget * child)
{
    int cx,cy;
    cx = child->fatherData.int_data_1;
    cy = child->fatherData.int_data_2;
    child->setLeft(cx * (cellWidth == -1 ?  0 : cellWidth));
    child->setTop(cy * (cellHeight == -1 ?  0 : cellHeight));
    child->setWidth((cellWidth == -1 ? getWidth() : cellWidth));
    child->setHeight((cellHeight == -1 ? getHeight() : cellHeight));
}

void GridWidget::initFatherData(Widget * child)
{
    if ((childCount == -1)) {
	child->fatherData.int_data_1 = 0;
	child->fatherData.int_data_2 = 0;
    } else {
	child->fatherData.int_data_1 = 0;
	child->fatherData.int_data_2 = childCount;
	childCount++;
    }
    placeChild(child);
}

void GridWidget::looseFatherData(Widget * child)
{
    // FIXME : Move childs...
}

void GridWidget::setPosition(Widget * child,int x,int y)
{
    child->fatherData.int_data_1 = x;
    child->fatherData.int_data_2 = y;
    placeChild(child);
}

void GridWidget::setFocus(int x,int y)
{
    focusedX = x;
    focusedY = y;
    int x0,y0,x1,y1;
    x0 = focusedX * (cellWidth == -1 ? w : cellWidth);
    y0 = focusedY * (cellHeight == -1 ? h : cellHeight);
    x1 = x0 + (cellWidth == -1 ? w : cellWidth) - 1;
    y1 = y0 + (cellHeight == -1 ? h : cellHeight) - 1;
    // Il dborde  droite ?
    if (x1 > w + childShiftX - 1) {
	childShiftX = x1 + 1 -  w;
    }
    // Il dborde en bas ?
    if (y1 > h + childShiftY - 1) {
	childShiftY = y1 + 1 -  h;
    }
        
    // Il commence avant XCurShift.
    if (x0 < childShiftX) {
	childShiftX = x0;
    }
    if (y0 < childShiftY) {
	childShiftY = y0;
    }
}

int GridWidget::getColumn(Widget * child) const
{
    return child->fatherData.int_data_1;
}

int GridWidget::getLine(Widget * child) const
{
    return child->fatherData.int_data_2;
}

void GridWidget::setCellWidth(int cellWidthParam) {
    cellWidth = cellWidthParam;
}

void GridWidget::setCellHeight(int cellHeightParam) {
    cellHeight = cellHeightParam;
}

int GridWidget::getCellWidth() const {
    return cellWidth;
}

int GridWidget::getCellHeight() const {
    return cellHeight;
}

GridWidget * newGridWidget()
{
    return new GridWidget();
}

JS_EXPORT_CLASS(GridWidget,Widget);
JS_RW_PROPERTY(GridWidget,cellWidth,getCellWidth,setCellWidth,int,"%i",0);
JS_RW_PROPERTY(GridWidget,cellHeight,getCellHeight,setCellHeight,int,"%i",0);
JS_NOCONTEXT_OBJECT_VOID_FUNCTION_2(GridWidget,setFocus,int,"%i",0,int,"%i",0);
JS_NOCONTEXT_OBJECT_FUNCTION_1(GridWidget,getColumn,int,"%i",0,Widget*,"%x",Widget::ClassInfo);
JS_NOCONTEXT_OBJECT_FUNCTION_1(GridWidget,getLine,int,"%i",0,Widget*,"%x",Widget::ClassInfo);
JS_NOCONTEXT_GLOBAL_FUNCTION_0(newGridWidget,GridWidget*,"%x",GridWidget::ClassInfo)
