#ifndef IMAGELOADER_H
#define IMAGELOADER_H 1

#include "JSNotifiable.h"
#include "ImageFactory.h"

#include <string>

class ImageLoader : public JSNotifiable {
    JS_EXPORTED_CLASS
protected:
    ImageUser * imageUser;
    
    std::string path;
    
    bool loading;
    bool loadResult;
    int sizeX,sizeY;
    bool forceChangeTrigger;
    
    virtual bool updateStatus();
    
public:
    ImageLoader();
    virtual ~ImageLoader();
    
    void load(const std::string & path);
    
    bool getLoading() const;
    bool getLoadResult() const;
    int getSizeX() const;
    int getSizeY() const;
    std::string getPath() const;
};


#endif

