#include "Application.h"
#include "JSNotifiable.h"

JSNotifiable::JSNotifiable() : Notifiable(), JSReflection::Object(Application::getJsContext())
{
}

JSNotifiable::~JSNotifiable()
{
}

void JSNotifiable::notified(Notifier * u)
{
    jsrlog("received notification\n");
    if (updateStatus()) {
	if (onStatusChange.length() > 0) {
	    evaluate(onStatusChange.c_str());
	}
    }
}

void JSNotifiable::checkStatusChange()
{
    if (updateStatus()) {
	if (onStatusChange.length() > 0) {
	    evaluate(onStatusChange.c_str());
	}
    }
}

bool JSNotifiable::updateStatus()
{
    return false;
}

void JSNotifiable::setOnStatusChange(const std::string & code)
{
    onStatusChange = code;
}

std::string JSNotifiable::getOnStatusChange() const
{
    return onStatusChange;
}

JS_EXPORT_CLASS(JSNotifiable,JSReflection::Object);
JS_NOCONTEXT_OBJECT_VOID_FUNCTION_0(JSNotifiable,checkStatusChange);
JS_RW_PROPERTY(JSNotifiable,onStatusChange,getOnStatusChange,setOnStatusChange,JSReflection::JS_String,"%s",0);

