#ifndef METADATA_H
#define METADATA_H

#include "Notifications.h"

#include <map>
#include <set>
#include <string>
#include <vector>

class MetaProvider : public InternalTask {
    friend class MetaUser;
    bool cancelAction;
    
    static void dump(void *,std::vector<std::string*> & );
    
    void addUser(MetaUser * m);
    void removeUser(MetaUser * m);
    int usageCount;
    bool ready;
    bool needUpdate;
    
    std::string path;
    std::map<std::string,std::string> values;
    
    virtual void run(TaskNotification * tn);
public:
    MetaProvider(const std::string & path);
    virtual ~MetaProvider();
    
    bool isReady();
    virtual bool suicide();
    virtual void fileChanged();
    bool getKey(const std::string & name, std::string & val);
    void setKey(const std::string & name, const std::string & val);
};

class MetaUser : public Notifier {
    friend class MetaProvider;
    static std::map<std::string,MetaProvider *> metadata;
    MetaProvider * mp;
    void bind(MetaProvider * m);
public:
    MetaUser(TaskQueue * which = InternalTask::syncTaskQueue);
    virtual ~MetaUser();
    
    void bind(const std::string path);
    void unbind();
    
    bool binded();
    bool isReady();
    
    bool getKey(const std::string & name, std::string & val);
    void setKey(const std::string & name, const std::string & val);
    
    static void invalidateFile(const std::string & path);
};

#endif

