#include <unistd.h>

#include <SDL.h>
#include <SDL_thread.h>

#include <set>

#include "jsreflect.h"
#include "Notifications.h"

Notifiable::Notifiable()
{
}

Notifiable::~Notifiable()
{
}

void Notifiable::notified(Notifier * u)
{
}

Notifier::Notifier(TaskQueue * it) : InternalTask(it)
{
    target = 0;
}

Notifier::~Notifier()
{
}

void Notifier::setTarget(Notifiable * t)
{
    target = t;
}

void Notifier::run(TaskNotification * tn)
{
    delete(tn);
    InternalTask::unlock();
    if (target) {
	target->notified(this);
    }
    InternalTask::lock();
}

//    target = 0;

#if 0

static SDL_mutex * alertMutex;
static std::set<Notifier *> alerts;
static int notifyFd;
static bool donotify;

void Notifier::emitThreadNotification()
{
    int tmp = 0;
    jsrlog("Notifier %#x signaling !\n",this );
    SDL_mutexP(alertMutex);
    if (!alerted) {
	alerts.insert(this);
	alerted = true;
    }
    if (donotify) {
	jsrlog("writing to fd!\n");
    	write(notifyFd,&tmp,1);
	donotify = false;
    }
    SDL_mutexV(alertMutex);
}

void Notifier::initialise(int fd)
{
    notifyFd = fd;
    donotify = true;
}

Notifier * Notifier::nextNotified()
{
    Notifier * result;
    
    SDL_mutexP(alertMutex);
    
    typeof(alerts.begin()) n = alerts.begin();
    if (n != alerts.end()) {
	result = *n;
    	result->alerted = false;
	alerts.erase(*n);
    } else {
	result = 0;
	donotify = true;
    }
    
    SDL_mutexV(alertMutex);
    
    return result;
}

Notifier::Notifier()
{
    target = 0;
    alerted = false;
}

Notifier::~Notifier()
{
    SDL_mutexP(alertMutex);
    alerts.erase(this);
    SDL_mutexV(alertMutex);
}

void Notifier::sendNotification()
{
    // FIXME : detect dead targets !
    jsrlog("Notification target is %#x\n", target);
    if (target) {
	target->notified(this);
    }
}

void Notifier::setTarget(Notifiable * t)
{
    // FIXME : detect dead targets !
    target = t;
}

Notifiable * Notifier::getTarget() const
{
    return target;
}

Notifiable::Notifiable()
{
}

Notifiable::~Notifiable()
{
}

#endif
