#ifndef PRODUCER_H
#define PRODUCER_H

#include <sys/types.h>

#include "jsreflect.h"
#include <string>

class Producer;
class XmlParser;

class Selectable {
    
    friend class Application;
    int fd;
protected:

    
    virtual void doRead()=0;
public:
    Selectable();
    virtual ~Selectable();
    
    int getFd() const;
    void setFd(int fd);
};

// Run a child process, takes its stdout
class Producer :public Selectable,public Notifiable,public JSReflection::Object {
    JS_EXPORTED_CLASS
    
    friend class Application;
    std::string cmd;
    std::string received;
    JSReflection::JSClosure * newEntry;
    JSReflection::JSClosure * done;
    JSReflection::JSClosure * childExited;
    JSReflection::Object * root;
    
    bool isXmlConsummer;
    XmlParser * parser;
    int errStatus;
    class ChildProcess * child;
    void sendData(const std::string & data);
    virtual void parseReceived();
    virtual void doRead();
    virtual void notified(Notifier *);
public:
    Producer(const char * cmd,JSReflection::Object * root,JSReflection::JSClosure * newEntry,JSReflection::JSClosure * done,JSReflection::JSClosure * childdone);
    virtual ~Producer();
    
    void start();
    
    void cancel();
    void setXml();
};


#endif
