#ifndef STYLE_H
#define STYLE_H 1

#include "jsreflect.h"
#include "Widget.h"

#include <map>
#include <list>

class Style {
    friend class Style_XmlItem;
    friend class StyleFilter_XmlItem;
    friend class StyleValue_XmlItem;
    /// Attributes mapping key => value (evaluated at runtime)
    std::map<std::string,std::string> values;
    std::map<std::string,bool> filters;
public:
    Style();
    ~Style();
    
    void add(const Style & s);
    void applyTo(Widget * w);
    
    static std::map<std::string,std::list<Style*> > allStyles;
    
    static void applyStyle(Widget * w);
};

#endif

