#ifndef TIMER_H
#define TIMER_H

class Timer;

typedef struct CompareTimerClass {
    bool operator() (const Timer * a,const Timer * b) const;
};

class Timer {
    friend class CompareTimerClass;
    friend class Application;
protected:
    bool hasTimeout;
    long long timeoutAt;
public:
    Timer();
    virtual ~Timer();
    
    /// is it programmed to occur ?
    bool programmed() const;
    /// when programmed, returns the programed time
    long long nextTick() const;
    /// return the theorical tick time, inside tick 
    long long currentTick() const;
    
    void setNextTick(long long when);
    
    /// Called when now => timeoutAt
    virtual void tick();
};

#endif
